# Prints out list options and prompts for a numerical choice
def list_dialog(menu_title, the_list):

    # Print menu title and separator
    print('\n{}\n{}'.format(menu_title, string_separator(len(menu_title))))

    # If list is empty, print out that there are no items and return
    if len(the_list) <= 0:
        print("No Items to Display\n")
        return

    # Iterate over list items
    for item_number in range(len(the_list)):

        # If list item has a predefined line number, extract it and use that one
        the_number = the_list[item_number].get('n')
        if not the_number:
            # if the list item does not have a specified line number, then use the list index
            n = item_number

        else:
            n = the_number

        # Print out option number followed by option itself
        print('{:5} {}'.format(n, the_list[item_number]['title']))

    # Prompt user for a choice
    choice = input('> ')

    # Changing text to a number is risky, use try catch to catch if option was not numerical
    try:
        choice = int(choice)
    except ValueError:

        # If invalid input, return None
        return

    # If options do not come with their own line numbers and the choice was not within the options
    if not (0 <= choice < len(the_list)):
        # Notify user and return from function
        print("Choice not within options.\n\n")
        return

    return the_list[choice]


# Prints out title and waits for textual input from user
def text_dialog(title, default_text):
    return input(title)


# Helper function to print a title/menu separator
def string_separator(sep_length):
    retval = '{:-^{}}'.format('-', sep_length)
    return retval
